Skip to main content

Graph

Graph is a very useful data structure which has versatile applications in many fields. It is impossible to cover all the aspects of graph-related algorithm, (the same as all the other topics in the posts), we will focus on some basics, especially that may be useful in code interview.

The two basic components of a graph is vertex (or node) and edge. Vertices are connected by edges. Graph can be directed graph or un-directed graph. The directed graph has directed edges; the undirected has undirected edges.

The common representation of a graph can be adjacent matrix or list. If use adjacent matrix, the element is usually set as 0 or 1. 0 means there is no edge, and 1 mean connected. If use adjacent list, usually the index of the list is the source node, and the elements in the list is the connected nodes from the source.

Other important concepts are the indegrees and outdegrees.  The indegree of a node means the number of edges pointing to it; the outdegree of a node means the number of edges originating from it. These two concepts are very useful in topologic sort: when the nodes has dependencies.

Besides to the common breadth-first-search (bfs), depth-first-searh (dfs), union-find (uf), there are many graph algorithm named after someone's name, such as Dijkstra algorithm. In general, the algorithm named after someone's name are designed only for some specific questions (Dijkstra however is an outlier), the chance to see them in tech interview is not very high.

To sum up,

1. graph is a useful data structure having many applications;

2. the edge could have directions;

3. the nodes could have dependencies;

4. the common basic algorithms about graph are dfs, bfs, and uf;

5. there are many algorithms about graph named after someone's' name(s), which is good to know.



Question List


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...